package it.unisannio.ding.ids.wedroid.app

import android.content.Context
import android.content.SharedPreferences
import androidx.appcompat.app.AppCompatActivity
import android.os.Bundle
import android.util.Log
import android.view.View
import android.widget.Toast
import it.unisannio.ding.ids.wedroid.app.util.SharedPreferenceHelper
import it.unisannio.ding.ids.wedroid.wrapper.api.LoginService
import it.unisannio.ding.ids.wedroid.wrapper.entity.UserPrototype
import kotlinx.android.synthetic.main.activity_login.*
import retrofit2.Call
import retrofit2.Callback
import retrofit2.Response
import retrofit2.Retrofit
import retrofit2.converter.gson.GsonConverterFactory

class LoginActivity : AppCompatActivity() {
    lateinit var sph: SharedPreferenceHelper

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_login)
        sph = SharedPreferenceHelper(this)

        val id = sph.userId
        val token = sph.token
        val url = sph.baseUrl
        Log.d("sharedPreference", "userId: $id\n token: $token\n url: $url")
    }

    fun loginButton(v: View) {
        if (username.text.isBlank() || istanceServer.text.isBlank() || password.text.isBlank()) {
            Toast.makeText(this, "Riempire tutti i campi", Toast.LENGTH_LONG)
                .show()
            return
        }


        val userNameText = username.text.toString()
        val passwordText = password.text.toString()

        val service = Retrofit.Builder()
            .addConverterFactory(GsonConverterFactory.create())
            .baseUrl(istanceServer.text.toString())
            .build()
            .create(LoginService::class.java)



        service.login(userNameText, passwordText).enqueue(object : Callback<UserPrototype> {
            override fun onFailure(call: Call<UserPrototype>, t: Throwable) {
                Toast.makeText(
                    applicationContext,
                    "Controlla la tua connessione internet",
                    Toast.LENGTH_LONG
                ).show()
            }

            override fun onResponse(call: Call<UserPrototype>, response: Response<UserPrototype>) {

                if (response.code() != 200) {
                    Toast.makeText(
                        applicationContext,
                        "Credenziali non corrette",
                        Toast.LENGTH_LONG
                    ).show()
                    return
                }
                val users = response.body()
                sph.baseUrl = istanceServer.text.toString()
                sph.token = users?.token
                sph.userId = users?.id

                Toast.makeText(
                    applicationContext,
                    "Login effettuato con successo",
                    Toast.LENGTH_LONG
                ).show()

            }

        })
    }
}
